import UIKit
import Flutter
import ProxicloudSDK
import Firebase

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
  override func application(
    
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    FirebaseApp.configure()
    GeneratedPluginRegistrant.register(with: self)
    PCManager.shared().setApiKey("5f50e62076e1ed3b45282848d15c1d5a8a03400846802e461bbc9a88769d560e", delegate: self)
    UNUserNotificationCenter.current().delegate = self
     UNUserNotificationCenter.current().requestAuthorization(options: [.alert, .sound, .badge]) { (granted, error) in
         guard error == nil else {
             // print error content here
             return
         }
     }
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
    
    @objc public func onPCEventLocationAuthorization(_ event: PCEventLocationAuthorization) {
       if event.locationAuthorization == .authorized {
         PCManager.shared().startMonitoring()
       }
    }
    
    override func userNotificationCenter(_ center: UNUserNotificationCenter,
             willPresent notification: UNNotification,
             withCompletionHandler completionHandler: @escaping (UNNotificationPresentationOptions) -> Void){
              // add this line
             PCManager.shared()?.passResponseToPcSdk(for: notification)
    }
    
    override func userNotificationCenter(_ center: UNUserNotificationCenter,
             didReceive response: UNNotificationResponse,
             withCompletionHandler completionHandler: @escaping () -> Void){
     // add this line
     PCManager.shared()?.passResponseToPcSdk(for: response.notification)
    }
}
