import 'dart:async';

import 'package:flutter/services.dart';

class Proxicloud {
  static const MethodChannel _channel = const MethodChannel('proxicloud');

  static reportEvent(String key, String value) {
    _channel.invokeMethod("reportEvent", {"key": key, "value": value});
  }

  static setNotificationsEnabled(bool enabled) {
    _channel.invokeMethod("setNotificationsEnabled", {"enabled": enabled});
  }

  static setAdvertisingIdentifier(String advertisingIdentifier) {
    _channel.invokeMethod("setAdvertisingIdentifier",
        {"advertisingIdentifier": advertisingIdentifier});
  }

  static setGdprConsentGiven(bool consentGiven) {
    _channel
        .invokeMethod("setGdprConsentGiven", {"consentGiven": consentGiven});
  }

  static handleIabTcfConsentInfo() {
    _channel.invokeMethod("handleIabTcfConsentInfo");
  }

  static setLogging(bool loggingEnabled) {
    _channel.invokeMethod("setLogging", {"loggingEnabled": loggingEnabled});
  }

  static setAttribute(String key, String value) {
    _channel.invokeMethod("setAttribute", {"key": key, "value": value});
  }

  static removeAttribute(String key) {
    _channel.invokeMethod("removeAttribute", {"key": key});
  }

  static removeAttributes() {
    _channel.invokeMethod("removeAttributes");
  }

  static setNotificationConversion(int conversion) {
    _channel
        .invokeMethod("setNotificationConversion", {"conversion": conversion});
  }

  static setApiKey(String apiKey) {
    _channel.invokeMethod("setApiKey", {"apiKey": apiKey});
  }

  static requestLocationAuthorization(bool request) {
    _channel
        .invokeMapMethod("requestLocationAuthorization", {"request": request});
  }

  static Future<Map<String, String>> getAttributes() async {
    return await _channel.invokeMapMethod("getAttributes");
  }
}
